=== drivers/remoteproc/Makefile ===
#
# Generic framework for controlling remote processors
#

obj-$(CONFIG_REMOTE_PROC)		+= remoteproc.o
obj-$(CONFIG_OMAP_REMOTE_PROC)		+= omap_remoteproc.o
obj-$(CONFIG_OMAP_RPRES)		+= rpres.o rpres_dev.o
