## linux-maguro 3.0.0-2.3

=== debian/changelog ===
linux-maguro (3.0.0-2.3) saucy; urgency=low

  * Enabled tools perf and related packages
  * Sync configs with mainline distro
    CONFIG_AUDIT=y
    CONFIG_AUDIT_GENERIC=y
    CONFIG_BLK_DEV_RAM_SIZE=65536
    CONFIG_CC_STACKPROTECTOR=y
    # CONFIG_COMPAT_BRK is not set
    CONFIG_DEFAULT_MMAP_MIN_ADDR=32768
    CONFIG_DEFAULT_SECURITY="apparmor"
    CONFIG_DEFAULT_SECURITY_APPARMOR=y
    # CONFIG_DEFAULT_SECURITY_DAC is not set
    # CONFIG_DEFAULT_SECURITY_SELINUX is not set
    # CONFIG_DEFAULT_SECURITY_SMACK is not set
    # CONFIG_DEFAULT_SECURITY_TOMOYO is not set
    # CONFIG_DEVKMEM is not set
    CONFIG_DEVTMPFS_MOUNT=y
    CONFIG_DNS_RESOLVER=m
    CONFIG_ECRYPT_FS=m
    # CONFIG_FANOTIFY_ACCESS_PERMISSIONS is not set
    # CONFIG_IMA is not set
    CONFIG_IP6_NF_SECURITY=m
    CONFIG_IP_NF_SECURITY=m
    CONFIG_KEYS=y
    CONFIG_KEYS_DEBUG_PROC_KEYS=y
    CONFIG_LSM_MMAP_MIN_ADDR=0
    CONFIG_NETFILTER_XT_TARGET_AUDIT=m
    CONFIG_NETFILTER_XT_TARGET_CONNSECMARK=m
    CONFIG_NETFILTER_XT_TARGET_SECMARK=m
    CONFIG_NETLABEL=y
    CONFIG_NETWORK_SECMARK=y
    CONFIG_NF_CONNTRACK_SECMARK=y
    CONFIG_SECCOMP=y
    CONFIG_SECURITY=y
    CONFIG_SECURITYFS=y
    CONFIG_SECURITY_APPARMOR=y
    CONFIG_SECURITY_APPARMOR_BOOTPARAM_VALUE=1
    CONFIG_SECURITY_NETWORK=y
    CONFIG_SECURITY_NETWORK_XFRM=y
    CONFIG_SECURITY_PATH=y
    CONFIG_SECURITY_SELINUX=y
    CONFIG_SECURITY_SELINUX_AVC_STATS=y
    CONFIG_SECURITY_SELINUX_BOOTPARAM=y
    CONFIG_SECURITY_SELINUX_BOOTPARAM_VALUE=0
    CONFIG_SECURITY_SELINUX_CHECKREQPROT_VALUE=1
    CONFIG_SECURITY_SELINUX_DEVELOP=y
    CONFIG_SECURITY_SELINUX_DISABLE=y
    # CONFIG_SECURITY_SELINUX_POLICYDB_VERSION_MAX is not set
    CONFIG_SECURITY_SMACK=y
    CONFIG_SECURITY_TOMOYO=y
    CONFIG_STRICT_DEVMEM=y
    CONFIG_SYN_COOKIES=y

 --  Tim Gardner <tim.gardner@canonical.com>  Fri, 31 May 2013 10:58:12 -0600

linux-maguro (3.0.0-1.2) saucy; urgency=low

  * UBUNTU: Added lttng
  * UBUNTU: [Config] Enable support for /proc/net/wireless

 -- Andy Whitcroft <apw@canonical.com>  Thu, 23 May 2013 11:51:19 +0100

linux-maguro (3.0.0-0.1) saucy; urgency=low

  * Based on git://phablet.ubuntu.com/CyanogenMod/android_kernel_samsung_tuna.git phablet-10.1
  * Build with gcc-4.6

 -- Tim Gardner <tim.gardner@canonical.com>  Mon, 20 May 2013 10:10:48 -0600

linux-maguro (3.0.0-0.0) saucy; urgency=low

  * changelog placeholder

 -- Andy Whitcroft <apw@canonical.com>  Fri, 03 May 2013 17:00:50 +0100
